<template xmlns:v-slot="http://www.w3.org/1999/XSL/Transform">
  <v-navigation-drawer
    id="core-navigation-drawer"
    v-model="drawer"
    :light="barColor !== 'rgba(228, 226, 226, 1), rgba(255, 255, 255, 0.7)'"
    :expand-on-hover="expandOnHover"
    mobile-breakpoint="960"
    app
    width="260"
    v-bind="$attrs"
  >
    <!--    :src="barImage"
            :dark="barColor !== 'rgba(228, 226, 226, 1), rgba(255, 255, 255, 0.7)'"
    -->

    <template v-slot:img="props">
      <v-img
        :gradient="`to bottom, ${barColor}`"
        v-bind="props"
      />
    </template>

    <v-divider class="mb-1" />

    <v-list
      dense
      nav
    >
      <v-list-item>
        <v-list-item-avatar
          class="align-self-center"
          color="white"
          contain
          size="62"
        >
          <v-img
            :src="logo"
            max-height="60"
          />
        </v-list-item-avatar>

        <v-list-item-content>
          <v-list-item-title
            class="display-1 font-weight-bold"
            style="color: #0031b7"
            v-text="profile.title"
          />
        </v-list-item-content>
      </v-list-item>
    </v-list>

    <v-divider class="mb-2" />

    <v-list expand nav>
      <div />

      <template v-for="(item, i) in computedItems">
        <base-item-group v-if="item.children&&item.visible" :key="`group-${i}`" :item="item"/>
        <base-item v-else-if="item.visible" :key="`item-${i}`" :item="item" />
      </template>
     

      <!-- <base-item :item="this.logout" /> -->
      <!-- Style cascading bug  -->
      <!-- https://github.com/vuetifyjs/vuetify/pull/8574 -->
      <div />
    </v-list>

  </v-navigation-drawer>
</template>

<script>
  // Utilities
  import { mapState } from "vuex";
  // import logo from "../../../assets/finalCMYK.png"

  export default {
    name: "DashboardCoreDrawer",

    props: {
      expandOnHover: {
        type: Boolean,
        default: false,
      },
    },

    data: () => ({
      active: [],
      logo: "",
      items: [
        
      ],
    }),

    computed: {
      ...mapState({
        barColor: state => state.drawer.barColor,
        barImage: state => state.drawer.barImage
      }),
      drawer: {
        get() {
          console.log("here22", this.$store.state.drawer)
          return this.$store.state.drawer.drawer;
        },
        set(val) {
          this.$store.commit("drawer/SET_DRAWER", val);
        },
      },
      computedItems() {
        return this.items.map(this.mapItem);
      },
      profile() {
        return {
          avatar: true,
          title: "myBuddy",
        };
      },
    },
    mounted(){
      console.log(this.current_panel_user)
      this.items = [
        {
          title: 'Home',
          icon: 'mdi-home',
          to: '/',
          visible: ["admin", "doctor"].includes(this.current_panel_user.role.name)
        },
        {
          title: 'Clinics',
          icon: 'mdi-hospital-building ',
          to: '/clinics',
          visible: ["admin"].includes(this.current_panel_user.role.name)
        },
        {
          title: 'Services',
          icon: 'mdi-hospital-box-outline ',
          to: '/services',
          visible: ["admin"].includes(this.current_panel_user.role.name)
        },
        {
          title: 'Services',
          icon: 'mdi-hospital-box-outline ',
          to: '/doctor_services',
          visible: ["doctor"].includes(this.current_panel_user.role.name)
        },
        {
          title: 'Visits',
          icon: 'mdi-file-eye-outline ',
          to: '/visits',
          visible: ["admin", "doctor"].includes(this.current_panel_user.role.name)
        },
        {
          title: 'Pets',
          icon: 'mdi-paw',
          to: '/pets',
          visible: ["admin"].includes(this.current_panel_user.role.name)
        },
        {
          title: "Users",
          icon: "mdi-account-group",
          group: "",
          visible: ["admin"].includes(this.current_panel_user.role.name),
          children: [
            {
              title: "Admins",
              icon: "mdi-account",
              to: "/admins",
              visible: true,
            },
            {
              title: "Clinic Admins",
              icon: "mdi-table-account",
              to: "/clinic_admins",
              visible: true
            },
            {
              title: "Doctors",
              icon: "mdi-doctor",
              to: "/doctors",
              visible: true
            },
            {
              title: "Pet Owners",
              icon: "mdi-dog-service",
              to: "/pet_owners",
              visible: true
            },
          ]
        },  
        {
          title: "General Info",
          icon: "mdi-clipboard-edit",
          to: "/general_infos",
          visible: ["admin"].includes(this.current_panel_user.role.name)
        },  
        {
          title: "Logout",
          icon: "mdi-logout",
          href: "/panel/auth/sign_out",
          visible: true
        },
        
      ]
    } ,
    methods: {
      mapItem(item) {
        return {
          ...item,
          children: item.children ? item.children.map(this.mapItem) : undefined,
          title: item.title,
        };
      },
      // isVisible(item) {
      //   let visible = true;
      //   if(item.to === "/facilitators")
      //     visible = visible && 
      // }
    },
  };
</script>

<style lang="sass">
  @import '~vuetify/src/styles/tools/_rtl.sass'

  #core-navigation-drawer
    .v-list-group__header.v-list-item--active:before
      opacity: .24

    .v-list-item
      &__icon--text,
      &__icon:first-child
        justify-content: center
        text-align: center
        width: 20px

        +ltr()
          margin-right: 24px
          margin-left: 12px !important

        +rtl()
          margin-left: 24px
          margin-right: 12px !important

    .v-list--dense
      .v-list-item
        &__icon--text,
        &__icon:first-child
          margin-top: 10px

    .v-list-group--sub-group
      .v-list-item
        +ltr()
          padding-left: 8px

        +rtl()
          padding-right: 8px

      .v-list-group__header
        +ltr()
          padding-right: 0

        +rtl()
          padding-right: 0

        .v-list-item__icon--text
          margin-top: 19px
          order: 0

        .v-list-group__header__prepend-icon
          order: 2

          +ltr()
            margin-right: 8px

          +rtl()
            margin-left: 8px

  /*.v-list--nav .v-list-item*/
  /*  padding: 0px*/
  /*  color: #0031b7*/

  /*!*.v-list-item__content*!*/
  /*!*  padding-right: 15px*!*/

  /*.v-list-group__items*/
  /*  padding-right: 20px*/

  /*  .theme--light.v-icon*/
  /*    color: #0031b7*/

  /*    .v-list .v-sheet .v-list--nav .v-icon*/
  /*      color: #0031b7*/

</style>
